package com.belkast.soap;

import org.apache.commons.csv.CSVFormat;
import org.apache.commons.csv.CSVRecord;

import java.io.*;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.*;

public class userVerify
{
    public static void main (String[] args) {
        System.out.println();
        Scanner myObj = new Scanner(System.in);  // Create a Scanner object

        String varFileName;
        while (true) {
            System.out.print("Please enter the CSV filename to validate : ");
            varFileName = myObj.nextLine();  // Read user input
            File thisFile = new File(varFileName);
            if (thisFile.exists())
            {
                break;
            }
        }

        Boolean varUserBlockEmpty = false;

        HashMap<String, Boolean> valueMap = new HashMap();
        valueMap.put("", true);
        valueMap.put("Y", true);
        valueMap.put("y", true);
        valueMap.put("N", false);
        valueMap.put("n", false);

        while (true) {
            System.out.print("Invalidate the line on empty column values? (Y/n) : ");
            String varAnswer = myObj.nextLine();

            if (varAnswer.toUpperCase().equals("Y") || varAnswer.toUpperCase().equals("N") || varAnswer == "")
            {
                varUserBlockEmpty = valueMap.get(varAnswer);
                break;
            }
        }

        System.out.println();
        System.out.println("CSV filename to validate : " + varFileName);
        System.out.println("CSV invalidate on empty  : " + varUserBlockEmpty);
        ArrayList thisCSV = readCSV(varFileName, true, varUserBlockEmpty);
        System.out.println();

        Iterator<Map> mapper1 = thisCSV.iterator();
        int varIter = 0;
        while (mapper1.hasNext())
        {
            varIter++;
            Map thisMap = mapper1.next();
            Iterator<Map.Entry<Integer, Integer>> it = thisMap.entrySet().iterator();
            while (it.hasNext())
            {
                Map.Entry<Integer, Integer> pair = it.next();
                System.out.println("record " + varIter + " : [" + pair.getKey() + "] => " + pair.getValue());
            }
            System.out.println();
        }
        boolean validfile = (!thisCSV.isEmpty());
        System.out.println("CSV file records  : " + varIter);
        System.out.println("CSV file is valid : " + validfile);
        System.out.println();
    }

        public static ArrayList readCSV (String thisFile, boolean fromUser, boolean blockEmpty)
        {
            int readNum = 0;
            int invalidNum = 0;
            ArrayList finalArray = new ArrayList();
            File varFile = new File (thisFile);
            if (!varFile.exists()) {
                System.out.println("CSV failure error : File not found. Please enter a valid filename!");
                System.exit(0);
            }

            String exceptionReason = null;
            Boolean failedOnException = false;
            Boolean parsedCorrectly = false;
            long lineNum = 0;

            while (!parsedCorrectly && !failedOnException) {
                try (final Reader in = new InputStreamReader(new FileInputStream(varFile.getPath()), "UTF-8"))
                {
                    String varHeader = new String();
                    varHeader = fileProcessor.readFirstLine(thisFile);
                    if (varHeader.length() == 0) {
                        System.out.println("CSV failure error  : Header line not found!");
                        return finalArray;
                    }

                    CSVFormat csvFormat = CSVFormat.EXCEL.builder()
                            .setHeader()
                            .setSkipHeaderRecord(false)
                            .setAllowMissingColumnNames(false)
                            .setIgnoreEmptyLines(true)
                            .setIgnoreSurroundingSpaces(true)
                            .setIgnoreHeaderCase(true)
                            .setTrim(true)
                            .build();

                    Iterable<CSVRecord> records = csvFormat.parse(in);

                    int thisHeaderLength = varHeader.split(",").length;
                    debugProcessor.writer(fromUser, "CSV header length  : " + thisHeaderLength);
                    debugProcessor.writer(fromUser, "CSV header tokens  : " + varHeader);
                    debugProcessor.writer(fromUser, "");

                    for (CSVRecord record : records) {
                        readNum++;
                        lineNum = record.getParser().getCurrentLineNumber();

                        boolean isValid = record.isConsistent();
                        int thisSize = record.size();
                        String thisLine = Files.readAllLines(Paths.get(thisFile)).get(Math.toIntExact(lineNum - 1));
                        Boolean validValues = true;

                        if (isValid)
                        {
                            Map thisMap = record.toMap();
                            Iterator<Map.Entry<Integer, Integer>> it = thisMap.entrySet().iterator();
                            while (it.hasNext())
                            {
                                Map.Entry<Integer, Integer> pair = it.next();
                                String thisVal = String.valueOf(pair.getValue());
                                if (blockEmpty && (pair.getValue() == null || thisVal.isEmpty()))
                                {
                                    validValues = false;
                                    debugProcessor.writer(fromUser, "!! line " + lineNum + " [failed] : check for empty token value [" + pair.getKey() + "]");
                                }
                            }
                        }

                        Map<String, String> thisMap = record.toMap();
                        if (isValid && validValues)
                        {
                            debugProcessor.writer(fromUser, "## line " + lineNum + " [passed]");
                            finalArray.add(thisMap);
                        }
                        else
                        {
                            invalidNum++;
                            debugProcessor.writer(fromUser, "!! line " + lineNum + " [failed] : " + thisLine);
                            debugProcessor.writer(fromUser, "!! line " + lineNum + " [failed] : " + record.toMap().toString());
                            if (thisSize > thisHeaderLength )
                            {
                                debugProcessor.writer(fromUser, "!! line " + lineNum + " [failed] : too many tokens or preceding line is wonky [map size is " + thisSize + ", should be " + thisHeaderLength + "]");
                            }
                        }
                    }
                }
                catch (Exception e)
                {
                    exceptionReason = e.getMessage();
                    failedOnException = true;
                    break;
                }
                parsedCorrectly = true;
            }

                if (readNum > 0)
                {
                    debugProcessor.writer(fromUser,"");
                }
                debugProcessor.writer(fromUser, "CSV lines read     : " + String.valueOf(readNum));
                debugProcessor.writer(fromUser, "CSV lines passed   : " + String.valueOf(readNum - invalidNum));
                debugProcessor.writer(fromUser, "CSV lines failed   : " + invalidNum);
                if (exceptionReason != null)
                {
                    debugProcessor.writer(fromUser, "CSV failure error  : " + exceptionReason);
                }

            if (invalidNum > 0)
            {
                finalArray = new ArrayList();
            }

            return finalArray;
        }
}
